var Server = {
    url: 'display.php',
    //url: 'http://localhost/cashisplay/display.php',
    busi: false,
    getbusi: false,
    xmlget: new XMLHttpRequest(),
    uid: false, // для облачной версии uid клиента
    localid: false, // для сетевой версии id кассы
    idget: 0, // id последней считанной записи (подробнее в php-файле)
    body: null,
    olderror: '',
    onparse: null, // процесс, запускающийся после изменения данных на странице
    oncontentloader: null, // процесс, запускающийся после ввода контента

    // Начало работы
    start: function() {
        // сохраняем ссылку на body
        var body = document.getElementById('body');
        if (body)
            this.body = body;
        else
            this.body = document.body;
        // сохраняем uid
        var hash = window.location.hash;
        if (hash && hash !== '#')
            if (hash.substr(1, 3) == 'id=')
                this.localid = hash.substr(4);
            else
                this.uid = hash.substr(1);
            // стартуем опрос сервера на получение данных в режиме онлайн
        setInterval(function() {
            Server.get();
        }, 300);
    },

    // Онлайн опрос на получение данных
    get: function() {
        // Если уже в процедуре опроса, то выход
        if (this.getbusi || this.busi)
            return;
        // забираем процедуру опроса
        this.getbusi = true;

        var formdata = new FormData();
        formdata.append('reg', 'get');
        formdata.append('id', this.idget); // id последней прочитанной записи
        if (this.uid !== false) // если облако
            formdata.append('key', this.uid);
        if (this.localid !== false) // если сетевая версия
            formdata.append('localid', this.localid);
        try {
            this.xmlget.open('POST', this.url, true);
        } catch (e) {
            this.getbusi = false;
            return;
        }

        // время закончилось или ошибка - отдаем процедуру
        this.xmlget.ontimeout = function() {
            Server.getbusi = false;
        }
        this.xmlget.onerror = function() {
            Server.getbusi = false;
        }
        this.xmlget.onreadystatechange = function() {
            if (Server.xmlget.readyState != 4) // если ответ еще не пришел
                return;

            if (Server.xmlget.status == 200) { // ответ пришел корректно
                var res = Server.xmlget.responseText;
                var rescontent = JSON.parse(res);
                if (rescontent.result == '0') { // в ответе ошибка
                    if (Server.olderror != rescontent.error) { // ошибку не дублируем
                        Server.olderror = rescontent.error;
                        alert(rescontent.error);
                    }
                } else
                if (rescontent.content) { // ошибки нет, парсим контент
                    Server.parse(rescontent.content, Server.body);
                    // выполняем процесс, назначенный после парсинга, если есть
                    if (Server.onparse)
                        Server.onparse();
                }
            }

            Server.getbusi = false;
        }

        this.xmlget.send(formdata);
    },

    contentloader: function() {
        if (this.oncontentloader)
            this.oncontentloader();
    },

    writeerror: function(inf) {
        var element = document.getElementById('errorwin');
        if (element) {
            element.innerHTML = inf;
            element.style.display = 'block';
        }
    },

    // а теперь рекурсия!!! 
    parse: function(record, parent) {
        var element = parent;
        if (Array.isArray(record)) {
            if (record.length == 1 && record[0].id) {
                this.idget = record[0].id;
                var content = record[0].content;
                try {
                    var rescontent = JSON.parse(content);
                } catch (error) {
                    this.writeerror('Array: ' + content);
                    return;
                }
                this.parse(rescontent, parent);
            } else
                for (var key in record) {
                    this.parse(record[key], parent);
                }
        } else
        if (typeof record == 'string' || typeof record == 'number') {
            element.innerHTML = element.innerHTML + record;
        } else
        if (typeof record == 'object') {
            if (record.id) {
                this.idget = record.id;
                try {
                    var rescontent = JSON.parse(record.content);
                } catch (error) {
                    this.writeerror("Object: " + record.content);
                    return;
                }
                this.parse(rescontent, parent);
            } else {
                if (record.reg)
                    switch (record.reg) {
                        case 'clear':
                        case 'write':
                            var _id = record.elid;
                            if (_id) {
                                var _element = document.getElementById(_id);
                                if (_element) {
                                    if (record.reg == 'clear')
                                        _element.innerHTML = '';
                                    element = _element;
                                }
                            }
                            break;
                        case 'style':
                            var _id = record.elid;
                            var _value = record.value;
                            var _style = record.css;
                            if (_id) {
                                var _element = document.getElementById(_id);
                                if (_element)
                                    _element.style[_style] = _value;
                            }
                            break;
                        case 'attr':
                            var _id = record.elid;
                            var _attr = record.attr;
                            var _value = record.value
                            if (_id) {
                                var _element = document.getElementById(_id);
                                if (_element)
                                    _element.setAttribute(_attr, _value);
                            }
                            break;
                        case 'add':
                            var _tag = record.tag;
                            var _exists = false;
                            if (!_tag)
                                _tag = 'div';
                            if (record.elid) {
                                element = document.getElementById(record.elid);
                                if (element) {
                                    element.innerHTML = '';
                                    _exists = true;
                                }
                            }
                            if (!_exists) {
                                element = document.createElement(_tag);
                                if (record.elid)
                                    element.setAttribute('id', record.elid);
                            }
                            if (record.class)
                                element.className = record.class;
                            if (!_exists) {
                                if (record.parent) {
                                    var _parent = document.getElementById(record.parent);
                                    if (_parent)
                                        _parent.appendChild(element);
                                    else
                                        parent.appendChild(element);
                                } else
                                    parent.appendChild(element);
                            }
                            break;
                        case 'destroy':
                            var _id = record.elid;
                            if (_id) {
                                var _element = document.getElementById(_id);
                                if (_element)
                                    _element.parentNode.removeChild(_element);
                            }
                            break;
                    }

                if (record.content)
                    this.parse(record.content, element);
            }
        }
    }
}

var timeout = 0;
var timeoutId = setInterval(function() { timeout++; }, 1000);

var Mes = {
    key: false,
    check: function() {
        if (this.key) {
            this.key = false;
            return true;
        }
        return false;
    },
    set: function() {
        this.key = true;
    }
};

function cleartimeout() {
    timeout = 0;
    return true;
}

function gettimeout() {
    return timeout;
}

function checkclicksettings() {
    return Mes.check();
}

function getordertovoice() {
    //return Zakazy.getordertovoice();
    return "";
}

document.addEventListener('DOMContentLoaded', function() {
    Server.start();

    document.getElementById('clientsettings').addEventListener('dblclick', function() {
        Mes.set();
    });

    setInterval(function() {
        var d = new Date();
        var el = document.getElementById('curtime');
        if (el) {
            var s = ('0' + d.getDate()).slice(-2) + '.' + ('0' + (d.getMonth() + 1)).slice(-2) + '.' + d.getFullYear() + ' ' + ('0' + d.getHours()).slice(-2) + ':' + ('0' + d.getMinutes()).slice(-2) + ':' + ('0' + d.getSeconds()).slice(-2);
            el.innerText = s;
        }
    }, 200);

    Server.contentloader();

}, false);

function includecss(filename) {
    var link = document.createElement("link");
    link.setAttribute("rel", "stylesheet");
    link.setAttribute("type", "text/css");
    link.setAttribute("href", filename);
    document.getElementsByTagName("head")[0].appendChild(link);
}

// для облака
function setuid(uid) {
    Server.uid = uid;
    //Server.smena();
    return true;
}

// для сетевой версии
function setlocalid(id) {
    Server.localid = id ? id : false;
    return true;
}